/* 
 * Identity API Endpoints
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 2
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Identity
{
    /// <summary>
    /// IdentityResponse
    /// </summary>
    [DataContract]
    public partial class IdentityResponse :  IEquatable<IdentityResponse>, IValidatableObject
    {
        /// <summary>
        /// Gets or Sets GenerationCodeSuffix
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum GenerationCodeSuffixEnum
        {
            
            /// <summary>
            /// Enum I for "I"
            /// </summary>
            [EnumMember(Value = "I")]
            I = 1,
            
            /// <summary>
            /// Enum II for "II"
            /// </summary>
            [EnumMember(Value = "II")]
            II = 2,
            
            /// <summary>
            /// Enum III for "III"
            /// </summary>
            [EnumMember(Value = "III")]
            III = 3,
            
            /// <summary>
            /// Enum IV for "IV"
            /// </summary>
            [EnumMember(Value = "IV")]
            IV = 4,
            
            /// <summary>
            /// Enum V for "V"
            /// </summary>
            [EnumMember(Value = "V")]
            V = 5,
            
            /// <summary>
            /// Enum VI for "VI"
            /// </summary>
            [EnumMember(Value = "VI")]
            VI = 6,
            
            /// <summary>
            /// Enum VII for "VII"
            /// </summary>
            [EnumMember(Value = "VII")]
            VII = 7,
            
            /// <summary>
            /// Enum VIII for "VIII"
            /// </summary>
            [EnumMember(Value = "VIII")]
            VIII = 8,
            
            /// <summary>
            /// Enum IX for "IX"
            /// </summary>
            [EnumMember(Value = "IX")]
            IX = 9,
            
            /// <summary>
            /// Enum X for "X"
            /// </summary>
            [EnumMember(Value = "X")]
            X = 10,
            
            /// <summary>
            /// Enum XI for "XI"
            /// </summary>
            [EnumMember(Value = "XI")]
            XI = 11,
            
            /// <summary>
            /// Enum XII for "XII"
            /// </summary>
            [EnumMember(Value = "XII")]
            XII = 12,
            
            /// <summary>
            /// Enum XIII for "XIII"
            /// </summary>
            [EnumMember(Value = "XIII")]
            XIII = 13,
            
            /// <summary>
            /// Enum XIV for "XIV"
            /// </summary>
            [EnumMember(Value = "XIV")]
            XIV = 14,
            
            /// <summary>
            /// Enum XV for "XV"
            /// </summary>
            [EnumMember(Value = "XV")]
            XV = 15,
            
            /// <summary>
            /// Enum Sr for "Sr"
            /// </summary>
            [EnumMember(Value = "Sr")]
            Sr = 16,
            
            /// <summary>
            /// Enum Jr for "Jr"
            /// </summary>
            [EnumMember(Value = "Jr")]
            Jr = 17,
            
            /// <summary>
            /// Enum SJ for "SJ"
            /// </summary>
            [EnumMember(Value = "SJ")]
            SJ = 18
        }

        /// <summary>
        /// Gets or Sets GenerationCodeSuffix
        /// </summary>
        [DataMember(Name="GenerationCodeSuffix", EmitDefaultValue=false)]
        public GenerationCodeSuffixEnum? GenerationCodeSuffix { get; set; }
        /// <summary>
        /// Gets or Sets SexType
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum SexTypeEnum
        {
            
            /// <summary>
            /// Enum M for "M"
            /// </summary>
            [EnumMember(Value = "M")]
            M = 1,
            
            /// <summary>
            /// Enum F for "F"
            /// </summary>
            [EnumMember(Value = "F")]
            F = 2
        }

        /// <summary>
        /// Gets or Sets SexType
        /// </summary>
        [DataMember(Name="SexType", EmitDefaultValue=false)]
        public SexTypeEnum? SexType { get; set; }
        /// <summary>
        /// Gets or Sets RaceCodes
        /// </summary>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum RaceCodesEnum
        {
            
            /// <summary>
            /// Enum A for "A"
            /// </summary>
            [EnumMember(Value = "A")]
            A = 1,
            
            /// <summary>
            /// Enum I for "I"
            /// </summary>
            [EnumMember(Value = "I")]
            I = 2,
            
            /// <summary>
            /// Enum P for "P"
            /// </summary>
            [EnumMember(Value = "P")]
            P = 3,
            
            /// <summary>
            /// Enum B for "B"
            /// </summary>
            [EnumMember(Value = "B")]
            B = 4,
            
            /// <summary>
            /// Enum W for "W"
            /// </summary>
            [EnumMember(Value = "W")]
            W = 5
        }


        /// <summary>
        /// Gets or Sets RaceCodes
        /// </summary>
        [DataMember(Name="RaceCodes", EmitDefaultValue=false)]
        public List<RaceCodesEnum> RaceCodes { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="IdentityResponse" /> class.
        /// </summary>
        /// <param name="BirthDate">BirthDate.</param>
        /// <param name="BirthLocation">BirthLocation.</param>
        /// <param name="BirthOrder">BirthOrder.</param>
        /// <param name="FirstName">FirstName.</param>
        /// <param name="GenerationCodeSuffix">GenerationCodeSuffix.</param>
        /// <param name="LastSurname">LastSurname.</param>
        /// <param name="MiddleName">MiddleName.</param>
        /// <param name="Score">Score.</param>
        /// <param name="SexType">SexType.</param>
        /// <param name="UniqueId">UniqueId.</param>
        /// <param name="MultipleBirthIndicator">MultipleBirthIndicator.</param>
        /// <param name="IsHispanicLatino">IsHispanicLatino.</param>
        /// <param name="RaceKey">RaceKey.</param>
        /// <param name="RaceCodes">RaceCodes.</param>
        /// <param name="Locals">Locals.</param>
        /// <param name="Names">Names.</param>
        /// <param name="ParentGuardianNames">ParentGuardianNames.</param>
        /// <param name="Enrollments">The students enrollments excluding DOC/DHS.</param>
        /// <param name="InactiveUniqueIds">Old (duplicate) UniqueIds for the student which were merged to the current UniqueId.</param>
        public IdentityResponse(DateTime? BirthDate = default(DateTime?), Location BirthLocation = default(Location), int? BirthOrder = default(int?), string FirstName = default(string), GenerationCodeSuffixEnum? GenerationCodeSuffix = default(GenerationCodeSuffixEnum?), string LastSurname = default(string), string MiddleName = default(string), double? Score = default(double?), SexTypeEnum? SexType = default(SexTypeEnum?), string UniqueId = default(string), bool? MultipleBirthIndicator = default(bool?), bool? IsHispanicLatino = default(bool?), string RaceKey = default(string), List<RaceCodesEnum> RaceCodes = default(List<RaceCodesEnum>), List<Local> Locals = default(List<Local>), List<Name> Names = default(List<Name>), List<ParentGuardianName> ParentGuardianNames = default(List<ParentGuardianName>), List<Enrollment> Enrollments = default(List<Enrollment>), List<string> InactiveUniqueIds = default(List<string>))
        {
            this.BirthDate = BirthDate;
            this.BirthLocation = BirthLocation;
            this.BirthOrder = BirthOrder;
            this.FirstName = FirstName;
            this.GenerationCodeSuffix = GenerationCodeSuffix;
            this.LastSurname = LastSurname;
            this.MiddleName = MiddleName;
            this.Score = Score;
            this.SexType = SexType;
            this.UniqueId = UniqueId;
            this.MultipleBirthIndicator = MultipleBirthIndicator;
            this.IsHispanicLatino = IsHispanicLatino;
            this.RaceKey = RaceKey;
            this.RaceCodes = RaceCodes;
            this.Locals = Locals;
            this.Names = Names;
            this.ParentGuardianNames = ParentGuardianNames;
            this.Enrollments = Enrollments;
            this.InactiveUniqueIds = InactiveUniqueIds;
        }
        
        /// <summary>
        /// Gets or Sets BirthDate
        /// </summary>
        [DataMember(Name="BirthDate", EmitDefaultValue=false)]
        public DateTime? BirthDate { get; set; }

        /// <summary>
        /// Gets or Sets BirthLocation
        /// </summary>
        [DataMember(Name="BirthLocation", EmitDefaultValue=false)]
        public Location BirthLocation { get; set; }

        /// <summary>
        /// Gets or Sets BirthOrder
        /// </summary>
        [DataMember(Name="BirthOrder", EmitDefaultValue=false)]
        public int? BirthOrder { get; set; }

        /// <summary>
        /// Gets or Sets FirstName
        /// </summary>
        [DataMember(Name="FirstName", EmitDefaultValue=false)]
        public string FirstName { get; set; }


        /// <summary>
        /// Gets or Sets LastSurname
        /// </summary>
        [DataMember(Name="LastSurname", EmitDefaultValue=false)]
        public string LastSurname { get; set; }

        /// <summary>
        /// Gets or Sets MiddleName
        /// </summary>
        [DataMember(Name="MiddleName", EmitDefaultValue=false)]
        public string MiddleName { get; set; }

        /// <summary>
        /// Gets or Sets Score
        /// </summary>
        [DataMember(Name="Score", EmitDefaultValue=false)]
        public double? Score { get; set; }


        /// <summary>
        /// Gets or Sets UniqueId
        /// </summary>
        [DataMember(Name="UniqueId", EmitDefaultValue=false)]
        public string UniqueId { get; set; }

        /// <summary>
        /// Gets or Sets MultipleBirthIndicator
        /// </summary>
        [DataMember(Name="MultipleBirthIndicator", EmitDefaultValue=false)]
        public bool? MultipleBirthIndicator { get; set; }

        /// <summary>
        /// Gets or Sets IsHispanicLatino
        /// </summary>
        [DataMember(Name="IsHispanicLatino", EmitDefaultValue=false)]
        public bool? IsHispanicLatino { get; set; }

        /// <summary>
        /// Gets or Sets RaceKey
        /// </summary>
        [DataMember(Name="RaceKey", EmitDefaultValue=false)]
        public string RaceKey { get; set; }


        /// <summary>
        /// Gets or Sets Locals
        /// </summary>
        [DataMember(Name="Locals", EmitDefaultValue=false)]
        public List<Local> Locals { get; set; }

        /// <summary>
        /// Gets or Sets Names
        /// </summary>
        [DataMember(Name="Names", EmitDefaultValue=false)]
        public List<Name> Names { get; set; }

        /// <summary>
        /// Gets or Sets ParentGuardianNames
        /// </summary>
        [DataMember(Name="ParentGuardianNames", EmitDefaultValue=false)]
        public List<ParentGuardianName> ParentGuardianNames { get; set; }

        /// <summary>
        /// The students enrollments excluding DOC/DHS
        /// </summary>
        /// <value>The students enrollments excluding DOC/DHS</value>
        [DataMember(Name="Enrollments", EmitDefaultValue=false)]
        public List<Enrollment> Enrollments { get; set; }

        /// <summary>
        /// Old (duplicate) UniqueIds for the student which were merged to the current UniqueId
        /// </summary>
        /// <value>Old (duplicate) UniqueIds for the student which were merged to the current UniqueId</value>
        [DataMember(Name="InactiveUniqueIds", EmitDefaultValue=false)]
        public List<string> InactiveUniqueIds { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class IdentityResponse {\n");
            sb.Append("  BirthDate: ").Append(BirthDate).Append("\n");
            sb.Append("  BirthLocation: ").Append(BirthLocation).Append("\n");
            sb.Append("  BirthOrder: ").Append(BirthOrder).Append("\n");
            sb.Append("  FirstName: ").Append(FirstName).Append("\n");
            sb.Append("  GenerationCodeSuffix: ").Append(GenerationCodeSuffix).Append("\n");
            sb.Append("  LastSurname: ").Append(LastSurname).Append("\n");
            sb.Append("  MiddleName: ").Append(MiddleName).Append("\n");
            sb.Append("  Score: ").Append(Score).Append("\n");
            sb.Append("  SexType: ").Append(SexType).Append("\n");
            sb.Append("  UniqueId: ").Append(UniqueId).Append("\n");
            sb.Append("  MultipleBirthIndicator: ").Append(MultipleBirthIndicator).Append("\n");
            sb.Append("  IsHispanicLatino: ").Append(IsHispanicLatino).Append("\n");
            sb.Append("  RaceKey: ").Append(RaceKey).Append("\n");
            sb.Append("  RaceCodes: ").Append(RaceCodes).Append("\n");
            sb.Append("  Locals: ").Append(Locals).Append("\n");
            sb.Append("  Names: ").Append(Names).Append("\n");
            sb.Append("  ParentGuardianNames: ").Append(ParentGuardianNames).Append("\n");
            sb.Append("  Enrollments: ").Append(Enrollments).Append("\n");
            sb.Append("  InactiveUniqueIds: ").Append(InactiveUniqueIds).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as IdentityResponse);
        }

        /// <summary>
        /// Returns true if IdentityResponse instances are equal
        /// </summary>
        /// <param name="input">Instance of IdentityResponse to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(IdentityResponse input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.BirthDate == input.BirthDate ||
                    (this.BirthDate != null &&
                    this.BirthDate.Equals(input.BirthDate))
                ) && 
                (
                    this.BirthLocation == input.BirthLocation ||
                    (this.BirthLocation != null &&
                    this.BirthLocation.Equals(input.BirthLocation))
                ) && 
                (
                    this.BirthOrder == input.BirthOrder ||
                    (this.BirthOrder != null &&
                    this.BirthOrder.Equals(input.BirthOrder))
                ) && 
                (
                    this.FirstName == input.FirstName ||
                    (this.FirstName != null &&
                    this.FirstName.Equals(input.FirstName))
                ) && 
                (
                    this.GenerationCodeSuffix == input.GenerationCodeSuffix ||
                    (this.GenerationCodeSuffix != null &&
                    this.GenerationCodeSuffix.Equals(input.GenerationCodeSuffix))
                ) && 
                (
                    this.LastSurname == input.LastSurname ||
                    (this.LastSurname != null &&
                    this.LastSurname.Equals(input.LastSurname))
                ) && 
                (
                    this.MiddleName == input.MiddleName ||
                    (this.MiddleName != null &&
                    this.MiddleName.Equals(input.MiddleName))
                ) && 
                (
                    this.Score == input.Score ||
                    (this.Score != null &&
                    this.Score.Equals(input.Score))
                ) && 
                (
                    this.SexType == input.SexType ||
                    (this.SexType != null &&
                    this.SexType.Equals(input.SexType))
                ) && 
                (
                    this.UniqueId == input.UniqueId ||
                    (this.UniqueId != null &&
                    this.UniqueId.Equals(input.UniqueId))
                ) && 
                (
                    this.MultipleBirthIndicator == input.MultipleBirthIndicator ||
                    (this.MultipleBirthIndicator != null &&
                    this.MultipleBirthIndicator.Equals(input.MultipleBirthIndicator))
                ) && 
                (
                    this.IsHispanicLatino == input.IsHispanicLatino ||
                    (this.IsHispanicLatino != null &&
                    this.IsHispanicLatino.Equals(input.IsHispanicLatino))
                ) && 
                (
                    this.RaceKey == input.RaceKey ||
                    (this.RaceKey != null &&
                    this.RaceKey.Equals(input.RaceKey))
                ) && 
                (
                    this.RaceCodes == input.RaceCodes ||
                    this.RaceCodes != null &&
                    this.RaceCodes.SequenceEqual(input.RaceCodes)
                ) && 
                (
                    this.Locals == input.Locals ||
                    this.Locals != null &&
                    this.Locals.SequenceEqual(input.Locals)
                ) && 
                (
                    this.Names == input.Names ||
                    this.Names != null &&
                    this.Names.SequenceEqual(input.Names)
                ) && 
                (
                    this.ParentGuardianNames == input.ParentGuardianNames ||
                    this.ParentGuardianNames != null &&
                    this.ParentGuardianNames.SequenceEqual(input.ParentGuardianNames)
                ) && 
                (
                    this.Enrollments == input.Enrollments ||
                    this.Enrollments != null &&
                    this.Enrollments.SequenceEqual(input.Enrollments)
                ) && 
                (
                    this.InactiveUniqueIds == input.InactiveUniqueIds ||
                    this.InactiveUniqueIds != null &&
                    this.InactiveUniqueIds.SequenceEqual(input.InactiveUniqueIds)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.BirthDate != null)
                    hashCode = hashCode * 59 + this.BirthDate.GetHashCode();
                if (this.BirthLocation != null)
                    hashCode = hashCode * 59 + this.BirthLocation.GetHashCode();
                if (this.BirthOrder != null)
                    hashCode = hashCode * 59 + this.BirthOrder.GetHashCode();
                if (this.FirstName != null)
                    hashCode = hashCode * 59 + this.FirstName.GetHashCode();
                if (this.GenerationCodeSuffix != null)
                    hashCode = hashCode * 59 + this.GenerationCodeSuffix.GetHashCode();
                if (this.LastSurname != null)
                    hashCode = hashCode * 59 + this.LastSurname.GetHashCode();
                if (this.MiddleName != null)
                    hashCode = hashCode * 59 + this.MiddleName.GetHashCode();
                if (this.Score != null)
                    hashCode = hashCode * 59 + this.Score.GetHashCode();
                if (this.SexType != null)
                    hashCode = hashCode * 59 + this.SexType.GetHashCode();
                if (this.UniqueId != null)
                    hashCode = hashCode * 59 + this.UniqueId.GetHashCode();
                if (this.MultipleBirthIndicator != null)
                    hashCode = hashCode * 59 + this.MultipleBirthIndicator.GetHashCode();
                if (this.IsHispanicLatino != null)
                    hashCode = hashCode * 59 + this.IsHispanicLatino.GetHashCode();
                if (this.RaceKey != null)
                    hashCode = hashCode * 59 + this.RaceKey.GetHashCode();
                if (this.RaceCodes != null)
                    hashCode = hashCode * 59 + this.RaceCodes.GetHashCode();
                if (this.Locals != null)
                    hashCode = hashCode * 59 + this.Locals.GetHashCode();
                if (this.Names != null)
                    hashCode = hashCode * 59 + this.Names.GetHashCode();
                if (this.ParentGuardianNames != null)
                    hashCode = hashCode * 59 + this.ParentGuardianNames.GetHashCode();
                if (this.Enrollments != null)
                    hashCode = hashCode * 59 + this.Enrollments.GetHashCode();
                if (this.InactiveUniqueIds != null)
                    hashCode = hashCode * 59 + this.InactiveUniqueIds.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
