/* 
 * Immunizations API Endpoints
 *
 * Coming soon(ish)! The WI Department of Public Instruction in conjunction with the WI Department of Health Services is working to facilitate the retrieval of HL7 immunization data from the WI Immunization Registry via the EdFi API.
 *
 * OpenAPI spec version: 1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Immunizations
{
    /// <summary>
    /// ImmunizationsPharmacyTreatmentAdministration
    /// </summary>
    [DataContract]
    public partial class ImmunizationsPharmacyTreatmentAdministration :  IEquatable<ImmunizationsPharmacyTreatmentAdministration>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="ImmunizationsPharmacyTreatmentAdministration" /> class.
        /// </summary>
        /// <param name="AdministeredDate">The date the treatment was administered..</param>
        /// <param name="AdministeredCode">The identification code for the treatment..</param>
        /// <param name="Waiver">The student&#39;s reason for not getting the treatment..</param>
        public ImmunizationsPharmacyTreatmentAdministration(DateTime? AdministeredDate = default(DateTime?), ImmunizationsCodedElement AdministeredCode = default(ImmunizationsCodedElement), string Waiver = default(string))
        {
            this.AdministeredDate = AdministeredDate;
            this.AdministeredCode = AdministeredCode;
            this.Waiver = Waiver;
        }
        
        /// <summary>
        /// The date the treatment was administered.
        /// </summary>
        /// <value>The date the treatment was administered.</value>
        [DataMember(Name="AdministeredDate", EmitDefaultValue=false)]
        public DateTime? AdministeredDate { get; set; }

        /// <summary>
        /// The identification code for the treatment.
        /// </summary>
        /// <value>The identification code for the treatment.</value>
        [DataMember(Name="AdministeredCode", EmitDefaultValue=false)]
        public ImmunizationsCodedElement AdministeredCode { get; set; }

        /// <summary>
        /// The student&#39;s reason for not getting the treatment.
        /// </summary>
        /// <value>The student&#39;s reason for not getting the treatment.</value>
        [DataMember(Name="Waiver", EmitDefaultValue=false)]
        public string Waiver { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ImmunizationsPharmacyTreatmentAdministration {\n");
            sb.Append("  AdministeredDate: ").Append(AdministeredDate).Append("\n");
            sb.Append("  AdministeredCode: ").Append(AdministeredCode).Append("\n");
            sb.Append("  Waiver: ").Append(Waiver).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ImmunizationsPharmacyTreatmentAdministration);
        }

        /// <summary>
        /// Returns true if ImmunizationsPharmacyTreatmentAdministration instances are equal
        /// </summary>
        /// <param name="input">Instance of ImmunizationsPharmacyTreatmentAdministration to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ImmunizationsPharmacyTreatmentAdministration input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.AdministeredDate == input.AdministeredDate ||
                    (this.AdministeredDate != null &&
                    this.AdministeredDate.Equals(input.AdministeredDate))
                ) && 
                (
                    this.AdministeredCode == input.AdministeredCode ||
                    (this.AdministeredCode != null &&
                    this.AdministeredCode.Equals(input.AdministeredCode))
                ) && 
                (
                    this.Waiver == input.Waiver ||
                    (this.Waiver != null &&
                    this.Waiver.Equals(input.Waiver))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.AdministeredDate != null)
                    hashCode = hashCode * 59 + this.AdministeredDate.GetHashCode();
                if (this.AdministeredCode != null)
                    hashCode = hashCode * 59 + this.AdministeredCode.GetHashCode();
                if (this.Waiver != null)
                    hashCode = hashCode * 59 + this.Waiver.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
