/* 
 * Immunizations API Endpoints
 *
 * Coming soon(ish)! The WI Department of Public Instruction in conjunction with the WI Department of Health Services is working to facilitate the retrieval of HL7 immunization data from the WI Immunization Registry via the EdFi API.
 *
 * OpenAPI spec version: 1
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Immunizations
{
    /// <summary>
    /// The base response for the student immunizations endpoint.
    /// </summary>
    [DataContract]
    public partial class ImmunizationsStudentResponse :  IEquatable<ImmunizationsStudentResponse>, IValidatableObject
    {
        /// <summary>
        /// 0&#x3D;Reject (WiR found an error with the DPI request - contact DPI); 1&#x3D;Success; 2&#x3D;MultipleMatches (If there are multiple matches please make sure the students information match in both EdFi and WiR); 3&#x3D;NotFound (If there are no matches please make sure the students information match in both EdFi and WiR)
        /// </summary>
        /// <value>0&#x3D;Reject (WiR found an error with the DPI request - contact DPI); 1&#x3D;Success; 2&#x3D;MultipleMatches (If there are multiple matches please make sure the students information match in both EdFi and WiR); 3&#x3D;NotFound (If there are no matches please make sure the students information match in both EdFi and WiR)</value>
        [JsonConverter(typeof(StringEnumConverter))]
        public enum StatusCodeEnum
        {
            
            /// <summary>
            /// Enum _0 for "0"
            /// </summary>
            [EnumMember(Value = "0")]
            _0 = 1,
            
            /// <summary>
            /// Enum _1 for "1"
            /// </summary>
            [EnumMember(Value = "1")]
            _1 = 2,
            
            /// <summary>
            /// Enum _2 for "2"
            /// </summary>
            [EnumMember(Value = "2")]
            _2 = 3,
            
            /// <summary>
            /// Enum _3 for "3"
            /// </summary>
            [EnumMember(Value = "3")]
            _3 = 4
        }

        /// <summary>
        /// 0&#x3D;Reject (WiR found an error with the DPI request - contact DPI); 1&#x3D;Success; 2&#x3D;MultipleMatches (If there are multiple matches please make sure the students information match in both EdFi and WiR); 3&#x3D;NotFound (If there are no matches please make sure the students information match in both EdFi and WiR)
        /// </summary>
        /// <value>0&#x3D;Reject (WiR found an error with the DPI request - contact DPI); 1&#x3D;Success; 2&#x3D;MultipleMatches (If there are multiple matches please make sure the students information match in both EdFi and WiR); 3&#x3D;NotFound (If there are no matches please make sure the students information match in both EdFi and WiR)</value>
        [DataMember(Name="statusCode", EmitDefaultValue=false)]
        public StatusCodeEnum? StatusCode { get; set; }
        /// <summary>
        /// Initializes a new instance of the <see cref="ImmunizationsStudentResponse" /> class.
        /// </summary>
        /// <param name="StatusCode">0&#x3D;Reject (WiR found an error with the DPI request - contact DPI); 1&#x3D;Success; 2&#x3D;MultipleMatches (If there are multiple matches please make sure the students information match in both EdFi and WiR); 3&#x3D;NotFound (If there are no matches please make sure the students information match in both EdFi and WiR).</param>
        /// <param name="Errors">Errors.</param>
        /// <param name="Data">The immunization history including the patient identifier (internal ID for WiR) and the studentReference and studentEducationOrganizationAssociationReference.</param>
        public ImmunizationsStudentResponse(StatusCodeEnum? StatusCode = default(StatusCodeEnum?), List<ImmunizationsError> Errors = default(List<ImmunizationsError>), ImmunizationsStudentHistory Data = default(ImmunizationsStudentHistory))
        {
            this.StatusCode = StatusCode;
            this.Errors = Errors;
            this.Data = Data;
        }
        

        /// <summary>
        /// The message corresponding to the status.
        /// </summary>
        /// <value>The message corresponding to the status.</value>
        [DataMember(Name="statusMessage", EmitDefaultValue=false)]
        public string StatusMessage { get; private set; }

        /// <summary>
        /// Gets or Sets Errors
        /// </summary>
        [DataMember(Name="errors", EmitDefaultValue=false)]
        public List<ImmunizationsError> Errors { get; set; }

        /// <summary>
        /// The immunization history including the patient identifier (internal ID for WiR) and the studentReference and studentEducationOrganizationAssociationReference
        /// </summary>
        /// <value>The immunization history including the patient identifier (internal ID for WiR) and the studentReference and studentEducationOrganizationAssociationReference</value>
        [DataMember(Name="data", EmitDefaultValue=false)]
        public ImmunizationsStudentHistory Data { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class ImmunizationsStudentResponse {\n");
            sb.Append("  StatusCode: ").Append(StatusCode).Append("\n");
            sb.Append("  StatusMessage: ").Append(StatusMessage).Append("\n");
            sb.Append("  Errors: ").Append(Errors).Append("\n");
            sb.Append("  Data: ").Append(Data).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as ImmunizationsStudentResponse);
        }

        /// <summary>
        /// Returns true if ImmunizationsStudentResponse instances are equal
        /// </summary>
        /// <param name="input">Instance of ImmunizationsStudentResponse to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(ImmunizationsStudentResponse input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.StatusCode == input.StatusCode ||
                    (this.StatusCode != null &&
                    this.StatusCode.Equals(input.StatusCode))
                ) && 
                (
                    this.StatusMessage == input.StatusMessage ||
                    (this.StatusMessage != null &&
                    this.StatusMessage.Equals(input.StatusMessage))
                ) && 
                (
                    this.Errors == input.Errors ||
                    this.Errors != null &&
                    this.Errors.SequenceEqual(input.Errors)
                ) && 
                (
                    this.Data == input.Data ||
                    (this.Data != null &&
                    this.Data.Equals(input.Data))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.StatusCode != null)
                    hashCode = hashCode * 59 + this.StatusCode.GetHashCode();
                if (this.StatusMessage != null)
                    hashCode = hashCode * 59 + this.StatusMessage.GetHashCode();
                if (this.Errors != null)
                    hashCode = hashCode * 59 + this.Errors.GetHashCode();
                if (this.Data != null)
                    hashCode = hashCode * 59 + this.Data.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
