/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Profiles.WiDpi.Public_Only_SPED
{
    /// <summary>
    /// EdFiStudentEducationOrganizationAssociationCohortYearReadable
    /// </summary>
    [DataContract]
    public partial class EdFiStudentEducationOrganizationAssociationCohortYearReadable :  IEquatable<EdFiStudentEducationOrganizationAssociationCohortYearReadable>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStudentEducationOrganizationAssociationCohortYearReadable" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiStudentEducationOrganizationAssociationCohortYearReadable() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStudentEducationOrganizationAssociationCohortYearReadable" /> class.
        /// </summary>
        /// <param name="CohortYearTypeDescriptor">The type of cohort year (9th grade, graduation). (required).</param>
        /// <param name="SchoolYearTypeReference">SchoolYearTypeReference (required).</param>
        public EdFiStudentEducationOrganizationAssociationCohortYearReadable(string CohortYearTypeDescriptor = default(string), EdFiSchoolYearTypeReference SchoolYearTypeReference = default(EdFiSchoolYearTypeReference))
        {
            // to ensure "CohortYearTypeDescriptor" is required (not null)
            if (CohortYearTypeDescriptor == null)
            {
                throw new InvalidDataException("CohortYearTypeDescriptor is a required property for EdFiStudentEducationOrganizationAssociationCohortYearReadable and cannot be null");
            }
            else
            {
                this.CohortYearTypeDescriptor = CohortYearTypeDescriptor;
            }
            // to ensure "SchoolYearTypeReference" is required (not null)
            if (SchoolYearTypeReference == null)
            {
                throw new InvalidDataException("SchoolYearTypeReference is a required property for EdFiStudentEducationOrganizationAssociationCohortYearReadable and cannot be null");
            }
            else
            {
                this.SchoolYearTypeReference = SchoolYearTypeReference;
            }
        }
        
        /// <summary>
        /// The type of cohort year (9th grade, graduation).
        /// </summary>
        /// <value>The type of cohort year (9th grade, graduation).</value>
        [DataMember(Name="cohortYearTypeDescriptor", EmitDefaultValue=false)]
        public string CohortYearTypeDescriptor { get; set; }

        /// <summary>
        /// Gets or Sets SchoolYearTypeReference
        /// </summary>
        [DataMember(Name="schoolYearTypeReference", EmitDefaultValue=false)]
        public EdFiSchoolYearTypeReference SchoolYearTypeReference { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiStudentEducationOrganizationAssociationCohortYearReadable {\n");
            sb.Append("  CohortYearTypeDescriptor: ").Append(CohortYearTypeDescriptor).Append("\n");
            sb.Append("  SchoolYearTypeReference: ").Append(SchoolYearTypeReference).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiStudentEducationOrganizationAssociationCohortYearReadable);
        }

        /// <summary>
        /// Returns true if EdFiStudentEducationOrganizationAssociationCohortYearReadable instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiStudentEducationOrganizationAssociationCohortYearReadable to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiStudentEducationOrganizationAssociationCohortYearReadable input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.CohortYearTypeDescriptor == input.CohortYearTypeDescriptor ||
                    (this.CohortYearTypeDescriptor != null &&
                    this.CohortYearTypeDescriptor.Equals(input.CohortYearTypeDescriptor))
                ) && 
                (
                    this.SchoolYearTypeReference == input.SchoolYearTypeReference ||
                    (this.SchoolYearTypeReference != null &&
                    this.SchoolYearTypeReference.Equals(input.SchoolYearTypeReference))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.CohortYearTypeDescriptor != null)
                    hashCode = hashCode * 59 + this.CohortYearTypeDescriptor.GetHashCode();
                if (this.SchoolYearTypeReference != null)
                    hashCode = hashCode * 59 + this.SchoolYearTypeReference.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // CohortYearTypeDescriptor (string) maxLength
            if(this.CohortYearTypeDescriptor != null && this.CohortYearTypeDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for CohortYearTypeDescriptor, length must be less than 306.", new [] { "CohortYearTypeDescriptor" });
            }

            yield break;
        }
    }

}
