/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiEducationOrganizationNetworkAssociation
    /// </summary>
    [DataContract]
    public partial class EdFiEducationOrganizationNetworkAssociation :  IEquatable<EdFiEducationOrganizationNetworkAssociation>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiEducationOrganizationNetworkAssociation" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiEducationOrganizationNetworkAssociation() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiEducationOrganizationNetworkAssociation" /> class.
        /// </summary>
        /// <param name="Id">Id.</param>
        /// <param name="EducationOrganizationNetworkReference">EducationOrganizationNetworkReference (required).</param>
        /// <param name="MemberEducationOrganizationReference">MemberEducationOrganizationReference (required).</param>
        /// <param name="BeginDate">The date on which the EducationOrganization joined this network..</param>
        /// <param name="EndDate">The date on which the EducationOrganization left this network..</param>
        /// <param name="Etag">A unique system-generated value that identifies the version of the resource..</param>
        public EdFiEducationOrganizationNetworkAssociation(string Id = default(string), EdFiEducationOrganizationNetworkReference EducationOrganizationNetworkReference = default(EdFiEducationOrganizationNetworkReference), EdFiEducationOrganizationReference MemberEducationOrganizationReference = default(EdFiEducationOrganizationReference), DateTime? BeginDate = default(DateTime?), DateTime? EndDate = default(DateTime?), string Etag = default(string))
        {
            // to ensure "EducationOrganizationNetworkReference" is required (not null)
            if (EducationOrganizationNetworkReference == null)
            {
                throw new InvalidDataException("EducationOrganizationNetworkReference is a required property for EdFiEducationOrganizationNetworkAssociation and cannot be null");
            }
            else
            {
                this.EducationOrganizationNetworkReference = EducationOrganizationNetworkReference;
            }
            // to ensure "MemberEducationOrganizationReference" is required (not null)
            if (MemberEducationOrganizationReference == null)
            {
                throw new InvalidDataException("MemberEducationOrganizationReference is a required property for EdFiEducationOrganizationNetworkAssociation and cannot be null");
            }
            else
            {
                this.MemberEducationOrganizationReference = MemberEducationOrganizationReference;
            }
            this.Id = Id;
            this.BeginDate = BeginDate;
            this.EndDate = EndDate;
            this.Etag = Etag;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets EducationOrganizationNetworkReference
        /// </summary>
        [DataMember(Name="educationOrganizationNetworkReference", EmitDefaultValue=false)]
        public EdFiEducationOrganizationNetworkReference EducationOrganizationNetworkReference { get; set; }

        /// <summary>
        /// Gets or Sets MemberEducationOrganizationReference
        /// </summary>
        [DataMember(Name="memberEducationOrganizationReference", EmitDefaultValue=false)]
        public EdFiEducationOrganizationReference MemberEducationOrganizationReference { get; set; }

        /// <summary>
        /// The date on which the EducationOrganization joined this network.
        /// </summary>
        /// <value>The date on which the EducationOrganization joined this network.</value>
        [DataMember(Name="beginDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? BeginDate { get; set; }

        /// <summary>
        /// The date on which the EducationOrganization left this network.
        /// </summary>
        /// <value>The date on which the EducationOrganization left this network.</value>
        [DataMember(Name="endDate", EmitDefaultValue=false)]
        [JsonConverter(typeof(SwaggerDateConverter))]
        public DateTime? EndDate { get; set; }

        /// <summary>
        /// A unique system-generated value that identifies the version of the resource.
        /// </summary>
        /// <value>A unique system-generated value that identifies the version of the resource.</value>
        [DataMember(Name="_etag", EmitDefaultValue=false)]
        public string Etag { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiEducationOrganizationNetworkAssociation {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  EducationOrganizationNetworkReference: ").Append(EducationOrganizationNetworkReference).Append("\n");
            sb.Append("  MemberEducationOrganizationReference: ").Append(MemberEducationOrganizationReference).Append("\n");
            sb.Append("  BeginDate: ").Append(BeginDate).Append("\n");
            sb.Append("  EndDate: ").Append(EndDate).Append("\n");
            sb.Append("  Etag: ").Append(Etag).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiEducationOrganizationNetworkAssociation);
        }

        /// <summary>
        /// Returns true if EdFiEducationOrganizationNetworkAssociation instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiEducationOrganizationNetworkAssociation to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiEducationOrganizationNetworkAssociation input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.EducationOrganizationNetworkReference == input.EducationOrganizationNetworkReference ||
                    (this.EducationOrganizationNetworkReference != null &&
                    this.EducationOrganizationNetworkReference.Equals(input.EducationOrganizationNetworkReference))
                ) && 
                (
                    this.MemberEducationOrganizationReference == input.MemberEducationOrganizationReference ||
                    (this.MemberEducationOrganizationReference != null &&
                    this.MemberEducationOrganizationReference.Equals(input.MemberEducationOrganizationReference))
                ) && 
                (
                    this.BeginDate == input.BeginDate ||
                    (this.BeginDate != null &&
                    this.BeginDate.Equals(input.BeginDate))
                ) && 
                (
                    this.EndDate == input.EndDate ||
                    (this.EndDate != null &&
                    this.EndDate.Equals(input.EndDate))
                ) && 
                (
                    this.Etag == input.Etag ||
                    (this.Etag != null &&
                    this.Etag.Equals(input.Etag))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.EducationOrganizationNetworkReference != null)
                    hashCode = hashCode * 59 + this.EducationOrganizationNetworkReference.GetHashCode();
                if (this.MemberEducationOrganizationReference != null)
                    hashCode = hashCode * 59 + this.MemberEducationOrganizationReference.GetHashCode();
                if (this.BeginDate != null)
                    hashCode = hashCode * 59 + this.BeginDate.GetHashCode();
                if (this.EndDate != null)
                    hashCode = hashCode * 59 + this.EndDate.GetHashCode();
                if (this.Etag != null)
                    hashCode = hashCode * 59 + this.Etag.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
