/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiPostSecondaryInstitutionMediumOfInstruction
    /// </summary>
    [DataContract]
    public partial class EdFiPostSecondaryInstitutionMediumOfInstruction :  IEquatable<EdFiPostSecondaryInstitutionMediumOfInstruction>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiPostSecondaryInstitutionMediumOfInstruction" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiPostSecondaryInstitutionMediumOfInstruction() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiPostSecondaryInstitutionMediumOfInstruction" /> class.
        /// </summary>
        /// <param name="MediumOfInstructionDescriptor">The categories in which an institution serves the students. (required).</param>
        public EdFiPostSecondaryInstitutionMediumOfInstruction(string MediumOfInstructionDescriptor = default(string))
        {
            // to ensure "MediumOfInstructionDescriptor" is required (not null)
            if (MediumOfInstructionDescriptor == null)
            {
                throw new InvalidDataException("MediumOfInstructionDescriptor is a required property for EdFiPostSecondaryInstitutionMediumOfInstruction and cannot be null");
            }
            else
            {
                this.MediumOfInstructionDescriptor = MediumOfInstructionDescriptor;
            }
        }
        
        /// <summary>
        /// The categories in which an institution serves the students.
        /// </summary>
        /// <value>The categories in which an institution serves the students.</value>
        [DataMember(Name="mediumOfInstructionDescriptor", EmitDefaultValue=false)]
        public string MediumOfInstructionDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiPostSecondaryInstitutionMediumOfInstruction {\n");
            sb.Append("  MediumOfInstructionDescriptor: ").Append(MediumOfInstructionDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiPostSecondaryInstitutionMediumOfInstruction);
        }

        /// <summary>
        /// Returns true if EdFiPostSecondaryInstitutionMediumOfInstruction instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiPostSecondaryInstitutionMediumOfInstruction to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiPostSecondaryInstitutionMediumOfInstruction input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.MediumOfInstructionDescriptor == input.MediumOfInstructionDescriptor ||
                    (this.MediumOfInstructionDescriptor != null &&
                    this.MediumOfInstructionDescriptor.Equals(input.MediumOfInstructionDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.MediumOfInstructionDescriptor != null)
                    hashCode = hashCode * 59 + this.MediumOfInstructionDescriptor.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // MediumOfInstructionDescriptor (string) maxLength
            if(this.MediumOfInstructionDescriptor != null && this.MediumOfInstructionDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for MediumOfInstructionDescriptor, length must be less than 306.", new [] { "MediumOfInstructionDescriptor" });
            }

            yield break;
        }
    }

}
