/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiProgramLearningStandard
    /// </summary>
    [DataContract]
    public partial class EdFiProgramLearningStandard :  IEquatable<EdFiProgramLearningStandard>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiProgramLearningStandard" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiProgramLearningStandard() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiProgramLearningStandard" /> class.
        /// </summary>
        /// <param name="LearningStandardReference">LearningStandardReference (required).</param>
        public EdFiProgramLearningStandard(EdFiLearningStandardReference LearningStandardReference = default(EdFiLearningStandardReference))
        {
            // to ensure "LearningStandardReference" is required (not null)
            if (LearningStandardReference == null)
            {
                throw new InvalidDataException("LearningStandardReference is a required property for EdFiProgramLearningStandard and cannot be null");
            }
            else
            {
                this.LearningStandardReference = LearningStandardReference;
            }
        }
        
        /// <summary>
        /// Gets or Sets LearningStandardReference
        /// </summary>
        [DataMember(Name="learningStandardReference", EmitDefaultValue=false)]
        public EdFiLearningStandardReference LearningStandardReference { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiProgramLearningStandard {\n");
            sb.Append("  LearningStandardReference: ").Append(LearningStandardReference).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiProgramLearningStandard);
        }

        /// <summary>
        /// Returns true if EdFiProgramLearningStandard instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiProgramLearningStandard to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiProgramLearningStandard input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.LearningStandardReference == input.LearningStandardReference ||
                    (this.LearningStandardReference != null &&
                    this.LearningStandardReference.Equals(input.LearningStandardReference))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.LearningStandardReference != null)
                    hashCode = hashCode * 59 + this.LearningStandardReference.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
