/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiReportCardGrade
    /// </summary>
    [DataContract]
    public partial class EdFiReportCardGrade :  IEquatable<EdFiReportCardGrade>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiReportCardGrade" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiReportCardGrade() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiReportCardGrade" /> class.
        /// </summary>
        /// <param name="GradeReference">GradeReference (required).</param>
        public EdFiReportCardGrade(EdFiGradeReference GradeReference = default(EdFiGradeReference))
        {
            // to ensure "GradeReference" is required (not null)
            if (GradeReference == null)
            {
                throw new InvalidDataException("GradeReference is a required property for EdFiReportCardGrade and cannot be null");
            }
            else
            {
                this.GradeReference = GradeReference;
            }
        }
        
        /// <summary>
        /// Gets or Sets GradeReference
        /// </summary>
        [DataMember(Name="gradeReference", EmitDefaultValue=false)]
        public EdFiGradeReference GradeReference { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiReportCardGrade {\n");
            sb.Append("  GradeReference: ").Append(GradeReference).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiReportCardGrade);
        }

        /// <summary>
        /// Returns true if EdFiReportCardGrade instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiReportCardGrade to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiReportCardGrade input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.GradeReference == input.GradeReference ||
                    (this.GradeReference != null &&
                    this.GradeReference.Equals(input.GradeReference))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.GradeReference != null)
                    hashCode = hashCode * 59 + this.GradeReference.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
