/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiRestraintEventReason
    /// </summary>
    [DataContract]
    public partial class EdFiRestraintEventReason :  IEquatable<EdFiRestraintEventReason>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiRestraintEventReason" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiRestraintEventReason() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiRestraintEventReason" /> class.
        /// </summary>
        /// <param name="RestraintEventReasonDescriptor">A categorization of the circumstances or reason for the RestraintEvent. (required).</param>
        public EdFiRestraintEventReason(string RestraintEventReasonDescriptor = default(string))
        {
            // to ensure "RestraintEventReasonDescriptor" is required (not null)
            if (RestraintEventReasonDescriptor == null)
            {
                throw new InvalidDataException("RestraintEventReasonDescriptor is a required property for EdFiRestraintEventReason and cannot be null");
            }
            else
            {
                this.RestraintEventReasonDescriptor = RestraintEventReasonDescriptor;
            }
        }
        
        /// <summary>
        /// A categorization of the circumstances or reason for the RestraintEvent.
        /// </summary>
        /// <value>A categorization of the circumstances or reason for the RestraintEvent.</value>
        [DataMember(Name="restraintEventReasonDescriptor", EmitDefaultValue=false)]
        public string RestraintEventReasonDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiRestraintEventReason {\n");
            sb.Append("  RestraintEventReasonDescriptor: ").Append(RestraintEventReasonDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiRestraintEventReason);
        }

        /// <summary>
        /// Returns true if EdFiRestraintEventReason instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiRestraintEventReason to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiRestraintEventReason input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.RestraintEventReasonDescriptor == input.RestraintEventReasonDescriptor ||
                    (this.RestraintEventReasonDescriptor != null &&
                    this.RestraintEventReasonDescriptor.Equals(input.RestraintEventReasonDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.RestraintEventReasonDescriptor != null)
                    hashCode = hashCode * 59 + this.RestraintEventReasonDescriptor.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // RestraintEventReasonDescriptor (string) maxLength
            if(this.RestraintEventReasonDescriptor != null && this.RestraintEventReasonDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for RestraintEventReasonDescriptor, length must be less than 306.", new [] { "RestraintEventReasonDescriptor" });
            }

            yield break;
        }
    }

}
