/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiStudentEducationOrganizationAssociationTribalAffiliation
    /// </summary>
    [DataContract]
    public partial class EdFiStudentEducationOrganizationAssociationTribalAffiliation :  IEquatable<EdFiStudentEducationOrganizationAssociationTribalAffiliation>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStudentEducationOrganizationAssociationTribalAffiliation" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiStudentEducationOrganizationAssociationTribalAffiliation() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiStudentEducationOrganizationAssociationTribalAffiliation" /> class.
        /// </summary>
        /// <param name="TribalAffiliationDescriptor">An American Indian tribe with which the student is affiliated as last reported to the education organization. (required).</param>
        public EdFiStudentEducationOrganizationAssociationTribalAffiliation(string TribalAffiliationDescriptor = default(string))
        {
            // to ensure "TribalAffiliationDescriptor" is required (not null)
            if (TribalAffiliationDescriptor == null)
            {
                throw new InvalidDataException("TribalAffiliationDescriptor is a required property for EdFiStudentEducationOrganizationAssociationTribalAffiliation and cannot be null");
            }
            else
            {
                this.TribalAffiliationDescriptor = TribalAffiliationDescriptor;
            }
        }
        
        /// <summary>
        /// An American Indian tribe with which the student is affiliated as last reported to the education organization.
        /// </summary>
        /// <value>An American Indian tribe with which the student is affiliated as last reported to the education organization.</value>
        [DataMember(Name="tribalAffiliationDescriptor", EmitDefaultValue=false)]
        public string TribalAffiliationDescriptor { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiStudentEducationOrganizationAssociationTribalAffiliation {\n");
            sb.Append("  TribalAffiliationDescriptor: ").Append(TribalAffiliationDescriptor).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiStudentEducationOrganizationAssociationTribalAffiliation);
        }

        /// <summary>
        /// Returns true if EdFiStudentEducationOrganizationAssociationTribalAffiliation instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiStudentEducationOrganizationAssociationTribalAffiliation to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiStudentEducationOrganizationAssociationTribalAffiliation input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.TribalAffiliationDescriptor == input.TribalAffiliationDescriptor ||
                    (this.TribalAffiliationDescriptor != null &&
                    this.TribalAffiliationDescriptor.Equals(input.TribalAffiliationDescriptor))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.TribalAffiliationDescriptor != null)
                    hashCode = hashCode * 59 + this.TribalAffiliationDescriptor.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // TribalAffiliationDescriptor (string) maxLength
            if(this.TribalAffiliationDescriptor != null && this.TribalAffiliationDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for TribalAffiliationDescriptor, length must be less than 306.", new [] { "TribalAffiliationDescriptor" });
            }

            yield break;
        }
    }

}
