/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiSurvey
    /// </summary>
    [DataContract]
    public partial class EdFiSurvey :  IEquatable<EdFiSurvey>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiSurvey" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiSurvey() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiSurvey" /> class.
        /// </summary>
        /// <param name="Id">Id.</param>
        /// <param name="_Namespace">Namespace for the Survey. (required).</param>
        /// <param name="SurveyIdentifier">The unique survey identifier from the survey tool. (required).</param>
        /// <param name="EducationOrganizationReference">EducationOrganizationReference.</param>
        /// <param name="SchoolYearTypeReference">SchoolYearTypeReference (required).</param>
        /// <param name="SessionReference">SessionReference.</param>
        /// <param name="NumberAdministered">Number of persons to whom this survey was administered..</param>
        /// <param name="SurveyCategoryDescriptor">The category or type of survey..</param>
        /// <param name="SurveyTitle">The title of the survey. (required).</param>
        /// <param name="Etag">A unique system-generated value that identifies the version of the resource..</param>
        public EdFiSurvey(string Id = default(string), string _Namespace = default(string), string SurveyIdentifier = default(string), EdFiEducationOrganizationReference EducationOrganizationReference = default(EdFiEducationOrganizationReference), EdFiSchoolYearTypeReference SchoolYearTypeReference = default(EdFiSchoolYearTypeReference), EdFiSessionReference SessionReference = default(EdFiSessionReference), int? NumberAdministered = default(int?), string SurveyCategoryDescriptor = default(string), string SurveyTitle = default(string), string Etag = default(string))
        {
            // to ensure "_Namespace" is required (not null)
            if (_Namespace == null)
            {
                throw new InvalidDataException("_Namespace is a required property for EdFiSurvey and cannot be null");
            }
            else
            {
                this._Namespace = _Namespace;
            }
            // to ensure "SurveyIdentifier" is required (not null)
            if (SurveyIdentifier == null)
            {
                throw new InvalidDataException("SurveyIdentifier is a required property for EdFiSurvey and cannot be null");
            }
            else
            {
                this.SurveyIdentifier = SurveyIdentifier;
            }
            // to ensure "SchoolYearTypeReference" is required (not null)
            if (SchoolYearTypeReference == null)
            {
                throw new InvalidDataException("SchoolYearTypeReference is a required property for EdFiSurvey and cannot be null");
            }
            else
            {
                this.SchoolYearTypeReference = SchoolYearTypeReference;
            }
            // to ensure "SurveyTitle" is required (not null)
            if (SurveyTitle == null)
            {
                throw new InvalidDataException("SurveyTitle is a required property for EdFiSurvey and cannot be null");
            }
            else
            {
                this.SurveyTitle = SurveyTitle;
            }
            this.Id = Id;
            this.EducationOrganizationReference = EducationOrganizationReference;
            this.SessionReference = SessionReference;
            this.NumberAdministered = NumberAdministered;
            this.SurveyCategoryDescriptor = SurveyCategoryDescriptor;
            this.Etag = Etag;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Namespace for the Survey.
        /// </summary>
        /// <value>Namespace for the Survey.</value>
        [DataMember(Name="namespace", EmitDefaultValue=false)]
        public string _Namespace { get; set; }

        /// <summary>
        /// The unique survey identifier from the survey tool.
        /// </summary>
        /// <value>The unique survey identifier from the survey tool.</value>
        [DataMember(Name="surveyIdentifier", EmitDefaultValue=false)]
        public string SurveyIdentifier { get; set; }

        /// <summary>
        /// Gets or Sets EducationOrganizationReference
        /// </summary>
        [DataMember(Name="educationOrganizationReference", EmitDefaultValue=false)]
        public EdFiEducationOrganizationReference EducationOrganizationReference { get; set; }

        /// <summary>
        /// Gets or Sets SchoolYearTypeReference
        /// </summary>
        [DataMember(Name="schoolYearTypeReference", EmitDefaultValue=false)]
        public EdFiSchoolYearTypeReference SchoolYearTypeReference { get; set; }

        /// <summary>
        /// Gets or Sets SessionReference
        /// </summary>
        [DataMember(Name="sessionReference", EmitDefaultValue=false)]
        public EdFiSessionReference SessionReference { get; set; }

        /// <summary>
        /// Number of persons to whom this survey was administered.
        /// </summary>
        /// <value>Number of persons to whom this survey was administered.</value>
        [DataMember(Name="numberAdministered", EmitDefaultValue=false)]
        public int? NumberAdministered { get; set; }

        /// <summary>
        /// The category or type of survey.
        /// </summary>
        /// <value>The category or type of survey.</value>
        [DataMember(Name="surveyCategoryDescriptor", EmitDefaultValue=false)]
        public string SurveyCategoryDescriptor { get; set; }

        /// <summary>
        /// The title of the survey.
        /// </summary>
        /// <value>The title of the survey.</value>
        [DataMember(Name="surveyTitle", EmitDefaultValue=false)]
        public string SurveyTitle { get; set; }

        /// <summary>
        /// A unique system-generated value that identifies the version of the resource.
        /// </summary>
        /// <value>A unique system-generated value that identifies the version of the resource.</value>
        [DataMember(Name="_etag", EmitDefaultValue=false)]
        public string Etag { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiSurvey {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  _Namespace: ").Append(_Namespace).Append("\n");
            sb.Append("  SurveyIdentifier: ").Append(SurveyIdentifier).Append("\n");
            sb.Append("  EducationOrganizationReference: ").Append(EducationOrganizationReference).Append("\n");
            sb.Append("  SchoolYearTypeReference: ").Append(SchoolYearTypeReference).Append("\n");
            sb.Append("  SessionReference: ").Append(SessionReference).Append("\n");
            sb.Append("  NumberAdministered: ").Append(NumberAdministered).Append("\n");
            sb.Append("  SurveyCategoryDescriptor: ").Append(SurveyCategoryDescriptor).Append("\n");
            sb.Append("  SurveyTitle: ").Append(SurveyTitle).Append("\n");
            sb.Append("  Etag: ").Append(Etag).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiSurvey);
        }

        /// <summary>
        /// Returns true if EdFiSurvey instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiSurvey to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiSurvey input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this._Namespace == input._Namespace ||
                    (this._Namespace != null &&
                    this._Namespace.Equals(input._Namespace))
                ) && 
                (
                    this.SurveyIdentifier == input.SurveyIdentifier ||
                    (this.SurveyIdentifier != null &&
                    this.SurveyIdentifier.Equals(input.SurveyIdentifier))
                ) && 
                (
                    this.EducationOrganizationReference == input.EducationOrganizationReference ||
                    (this.EducationOrganizationReference != null &&
                    this.EducationOrganizationReference.Equals(input.EducationOrganizationReference))
                ) && 
                (
                    this.SchoolYearTypeReference == input.SchoolYearTypeReference ||
                    (this.SchoolYearTypeReference != null &&
                    this.SchoolYearTypeReference.Equals(input.SchoolYearTypeReference))
                ) && 
                (
                    this.SessionReference == input.SessionReference ||
                    (this.SessionReference != null &&
                    this.SessionReference.Equals(input.SessionReference))
                ) && 
                (
                    this.NumberAdministered == input.NumberAdministered ||
                    (this.NumberAdministered != null &&
                    this.NumberAdministered.Equals(input.NumberAdministered))
                ) && 
                (
                    this.SurveyCategoryDescriptor == input.SurveyCategoryDescriptor ||
                    (this.SurveyCategoryDescriptor != null &&
                    this.SurveyCategoryDescriptor.Equals(input.SurveyCategoryDescriptor))
                ) && 
                (
                    this.SurveyTitle == input.SurveyTitle ||
                    (this.SurveyTitle != null &&
                    this.SurveyTitle.Equals(input.SurveyTitle))
                ) && 
                (
                    this.Etag == input.Etag ||
                    (this.Etag != null &&
                    this.Etag.Equals(input.Etag))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this._Namespace != null)
                    hashCode = hashCode * 59 + this._Namespace.GetHashCode();
                if (this.SurveyIdentifier != null)
                    hashCode = hashCode * 59 + this.SurveyIdentifier.GetHashCode();
                if (this.EducationOrganizationReference != null)
                    hashCode = hashCode * 59 + this.EducationOrganizationReference.GetHashCode();
                if (this.SchoolYearTypeReference != null)
                    hashCode = hashCode * 59 + this.SchoolYearTypeReference.GetHashCode();
                if (this.SessionReference != null)
                    hashCode = hashCode * 59 + this.SessionReference.GetHashCode();
                if (this.NumberAdministered != null)
                    hashCode = hashCode * 59 + this.NumberAdministered.GetHashCode();
                if (this.SurveyCategoryDescriptor != null)
                    hashCode = hashCode * 59 + this.SurveyCategoryDescriptor.GetHashCode();
                if (this.SurveyTitle != null)
                    hashCode = hashCode * 59 + this.SurveyTitle.GetHashCode();
                if (this.Etag != null)
                    hashCode = hashCode * 59 + this.Etag.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // _Namespace (string) maxLength
            if(this._Namespace != null && this._Namespace.Length > 255)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for _Namespace, length must be less than 255.", new [] { "_Namespace" });
            }

            // SurveyIdentifier (string) maxLength
            if(this.SurveyIdentifier != null && this.SurveyIdentifier.Length > 60)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SurveyIdentifier, length must be less than 60.", new [] { "SurveyIdentifier" });
            }

            // SurveyCategoryDescriptor (string) maxLength
            if(this.SurveyCategoryDescriptor != null && this.SurveyCategoryDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SurveyCategoryDescriptor, length must be less than 306.", new [] { "SurveyCategoryDescriptor" });
            }

            // SurveyTitle (string) maxLength
            if(this.SurveyTitle != null && this.SurveyTitle.Length > 255)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SurveyTitle, length must be less than 255.", new [] { "SurveyTitle" });
            }

            yield break;
        }
    }

}
