/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiSurveyQuestionReference
    /// </summary>
    [DataContract]
    public partial class EdFiSurveyQuestionReference :  IEquatable<EdFiSurveyQuestionReference>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiSurveyQuestionReference" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiSurveyQuestionReference() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiSurveyQuestionReference" /> class.
        /// </summary>
        /// <param name="_Namespace">Namespace for the Survey. (required).</param>
        /// <param name="QuestionCode">The identifying code for the question, unique for the survey. (required).</param>
        /// <param name="SurveyIdentifier">The unique survey identifier from the survey tool. (required).</param>
        /// <param name="Link">Link.</param>
        public EdFiSurveyQuestionReference(string _Namespace = default(string), string QuestionCode = default(string), string SurveyIdentifier = default(string), Link Link = default(Link))
        {
            // to ensure "_Namespace" is required (not null)
            if (_Namespace == null)
            {
                throw new InvalidDataException("_Namespace is a required property for EdFiSurveyQuestionReference and cannot be null");
            }
            else
            {
                this._Namespace = _Namespace;
            }
            // to ensure "QuestionCode" is required (not null)
            if (QuestionCode == null)
            {
                throw new InvalidDataException("QuestionCode is a required property for EdFiSurveyQuestionReference and cannot be null");
            }
            else
            {
                this.QuestionCode = QuestionCode;
            }
            // to ensure "SurveyIdentifier" is required (not null)
            if (SurveyIdentifier == null)
            {
                throw new InvalidDataException("SurveyIdentifier is a required property for EdFiSurveyQuestionReference and cannot be null");
            }
            else
            {
                this.SurveyIdentifier = SurveyIdentifier;
            }
            this.Link = Link;
        }
        
        /// <summary>
        /// Namespace for the Survey.
        /// </summary>
        /// <value>Namespace for the Survey.</value>
        [DataMember(Name="namespace", EmitDefaultValue=false)]
        public string _Namespace { get; set; }

        /// <summary>
        /// The identifying code for the question, unique for the survey.
        /// </summary>
        /// <value>The identifying code for the question, unique for the survey.</value>
        [DataMember(Name="questionCode", EmitDefaultValue=false)]
        public string QuestionCode { get; set; }

        /// <summary>
        /// The unique survey identifier from the survey tool.
        /// </summary>
        /// <value>The unique survey identifier from the survey tool.</value>
        [DataMember(Name="surveyIdentifier", EmitDefaultValue=false)]
        public string SurveyIdentifier { get; set; }

        /// <summary>
        /// Gets or Sets Link
        /// </summary>
        [DataMember(Name="link", EmitDefaultValue=false)]
        public Link Link { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiSurveyQuestionReference {\n");
            sb.Append("  _Namespace: ").Append(_Namespace).Append("\n");
            sb.Append("  QuestionCode: ").Append(QuestionCode).Append("\n");
            sb.Append("  SurveyIdentifier: ").Append(SurveyIdentifier).Append("\n");
            sb.Append("  Link: ").Append(Link).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiSurveyQuestionReference);
        }

        /// <summary>
        /// Returns true if EdFiSurveyQuestionReference instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiSurveyQuestionReference to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiSurveyQuestionReference input)
        {
            if (input == null)
                return false;

            return 
                (
                    this._Namespace == input._Namespace ||
                    (this._Namespace != null &&
                    this._Namespace.Equals(input._Namespace))
                ) && 
                (
                    this.QuestionCode == input.QuestionCode ||
                    (this.QuestionCode != null &&
                    this.QuestionCode.Equals(input.QuestionCode))
                ) && 
                (
                    this.SurveyIdentifier == input.SurveyIdentifier ||
                    (this.SurveyIdentifier != null &&
                    this.SurveyIdentifier.Equals(input.SurveyIdentifier))
                ) && 
                (
                    this.Link == input.Link ||
                    (this.Link != null &&
                    this.Link.Equals(input.Link))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this._Namespace != null)
                    hashCode = hashCode * 59 + this._Namespace.GetHashCode();
                if (this.QuestionCode != null)
                    hashCode = hashCode * 59 + this.QuestionCode.GetHashCode();
                if (this.SurveyIdentifier != null)
                    hashCode = hashCode * 59 + this.SurveyIdentifier.GetHashCode();
                if (this.Link != null)
                    hashCode = hashCode * 59 + this.Link.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // _Namespace (string) maxLength
            if(this._Namespace != null && this._Namespace.Length > 255)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for _Namespace, length must be less than 255.", new [] { "_Namespace" });
            }

            // QuestionCode (string) maxLength
            if(this.QuestionCode != null && this.QuestionCode.Length > 60)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for QuestionCode, length must be less than 60.", new [] { "QuestionCode" });
            }

            // SurveyIdentifier (string) maxLength
            if(this.SurveyIdentifier != null && this.SurveyIdentifier.Length > 60)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for SurveyIdentifier, length must be less than 60.", new [] { "SurveyIdentifier" });
            }

            yield break;
        }
    }

}
