/* 
 * Ed-Fi Operational Data Store API
 *
 * The Ed-Fi ODS / API enables applications to read and write education data stored in an Ed-Fi ODS through a secure REST interface.  ***  > *Note: Consumers of ODS / API information should sanitize all data for display and storage. The ODS / API provides reasonable safeguards against cross-site scripting attacks and other malicious content, but the platform does not and cannot guarantee that the data it contains is free of all potentially harmful content.*  *** 
 *
 * OpenAPI spec version: 3
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 */

using System;
using System.Linq;
using System.IO;
using System.Text;
using System.Text.RegularExpressions;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Runtime.Serialization;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using System.ComponentModel.DataAnnotations;
using SwaggerDateConverter = EdFi.OdsApi.Sdk.Client.SwaggerDateConverter;

namespace EdFi.OdsApi.Sdk.Models.Resources
{
    /// <summary>
    /// EdFiXAssessmentRosterStudentAssessmentRegistration
    /// </summary>
    [DataContract]
    public partial class EdFiXAssessmentRosterStudentAssessmentRegistration :  IEquatable<EdFiXAssessmentRosterStudentAssessmentRegistration>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXAssessmentRosterStudentAssessmentRegistration" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected EdFiXAssessmentRosterStudentAssessmentRegistration() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="EdFiXAssessmentRosterStudentAssessmentRegistration" /> class.
        /// </summary>
        /// <param name="Id">Id.</param>
        /// <param name="AssessmentAdministrationReference">AssessmentAdministrationReference (required).</param>
        /// <param name="ReportingEducationOrganizationReference">ReportingEducationOrganizationReference.</param>
        /// <param name="StudentEducationOrganizationAssociationReference">StudentEducationOrganizationAssociationReference (required).</param>
        /// <param name="TestingEducationOrganizationReference">TestingEducationOrganizationReference.</param>
        /// <param name="AssessmentCustomizations">An unordered collection of studentAssessmentRegistrationAssessmentCustomizations. Key/value pairs which may be used to facilitate customization of an assessment or to support vendor reporting/analysis.</param>
        /// <param name="PlatformTypeDescriptor">The environment or format in which the assessment is expected to be administred.</param>
        /// <param name="Etag">A unique system-generated value that identifies the version of the resource..</param>
        public EdFiXAssessmentRosterStudentAssessmentRegistration(string Id = default(string), EdFiXAssessmentRosterAssessmentAdministrationReference AssessmentAdministrationReference = default(EdFiXAssessmentRosterAssessmentAdministrationReference), EdFiEducationOrganizationReference ReportingEducationOrganizationReference = default(EdFiEducationOrganizationReference), EdFiStudentEducationOrganizationAssociationReference StudentEducationOrganizationAssociationReference = default(EdFiStudentEducationOrganizationAssociationReference), EdFiEducationOrganizationReference TestingEducationOrganizationReference = default(EdFiEducationOrganizationReference), List<EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization> AssessmentCustomizations = default(List<EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization>), string PlatformTypeDescriptor = default(string), string Etag = default(string))
        {
            // to ensure "AssessmentAdministrationReference" is required (not null)
            if (AssessmentAdministrationReference == null)
            {
                throw new InvalidDataException("AssessmentAdministrationReference is a required property for EdFiXAssessmentRosterStudentAssessmentRegistration and cannot be null");
            }
            else
            {
                this.AssessmentAdministrationReference = AssessmentAdministrationReference;
            }
            // to ensure "StudentEducationOrganizationAssociationReference" is required (not null)
            if (StudentEducationOrganizationAssociationReference == null)
            {
                throw new InvalidDataException("StudentEducationOrganizationAssociationReference is a required property for EdFiXAssessmentRosterStudentAssessmentRegistration and cannot be null");
            }
            else
            {
                this.StudentEducationOrganizationAssociationReference = StudentEducationOrganizationAssociationReference;
            }
            this.Id = Id;
            this.ReportingEducationOrganizationReference = ReportingEducationOrganizationReference;
            this.TestingEducationOrganizationReference = TestingEducationOrganizationReference;
            this.AssessmentCustomizations = AssessmentCustomizations;
            this.PlatformTypeDescriptor = PlatformTypeDescriptor;
            this.Etag = Etag;
        }
        
        /// <summary>
        /// Gets or Sets Id
        /// </summary>
        [DataMember(Name="id", EmitDefaultValue=false)]
        public string Id { get; set; }

        /// <summary>
        /// Gets or Sets AssessmentAdministrationReference
        /// </summary>
        [DataMember(Name="assessmentAdministrationReference", EmitDefaultValue=false)]
        public EdFiXAssessmentRosterAssessmentAdministrationReference AssessmentAdministrationReference { get; set; }

        /// <summary>
        /// Gets or Sets ReportingEducationOrganizationReference
        /// </summary>
        [DataMember(Name="reportingEducationOrganizationReference", EmitDefaultValue=false)]
        public EdFiEducationOrganizationReference ReportingEducationOrganizationReference { get; set; }

        /// <summary>
        /// Gets or Sets StudentEducationOrganizationAssociationReference
        /// </summary>
        [DataMember(Name="studentEducationOrganizationAssociationReference", EmitDefaultValue=false)]
        public EdFiStudentEducationOrganizationAssociationReference StudentEducationOrganizationAssociationReference { get; set; }

        /// <summary>
        /// Gets or Sets TestingEducationOrganizationReference
        /// </summary>
        [DataMember(Name="testingEducationOrganizationReference", EmitDefaultValue=false)]
        public EdFiEducationOrganizationReference TestingEducationOrganizationReference { get; set; }

        /// <summary>
        /// An unordered collection of studentAssessmentRegistrationAssessmentCustomizations. Key/value pairs which may be used to facilitate customization of an assessment or to support vendor reporting/analysis
        /// </summary>
        /// <value>An unordered collection of studentAssessmentRegistrationAssessmentCustomizations. Key/value pairs which may be used to facilitate customization of an assessment or to support vendor reporting/analysis</value>
        [DataMember(Name="assessmentCustomizations", EmitDefaultValue=false)]
        public List<EdFiXAssessmentRosterStudentAssessmentRegistrationAssessmentCustomization> AssessmentCustomizations { get; set; }

        /// <summary>
        /// The environment or format in which the assessment is expected to be administred
        /// </summary>
        /// <value>The environment or format in which the assessment is expected to be administred</value>
        [DataMember(Name="platformTypeDescriptor", EmitDefaultValue=false)]
        public string PlatformTypeDescriptor { get; set; }

        /// <summary>
        /// A unique system-generated value that identifies the version of the resource.
        /// </summary>
        /// <value>A unique system-generated value that identifies the version of the resource.</value>
        [DataMember(Name="_etag", EmitDefaultValue=false)]
        public string Etag { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            var sb = new StringBuilder();
            sb.Append("class EdFiXAssessmentRosterStudentAssessmentRegistration {\n");
            sb.Append("  Id: ").Append(Id).Append("\n");
            sb.Append("  AssessmentAdministrationReference: ").Append(AssessmentAdministrationReference).Append("\n");
            sb.Append("  ReportingEducationOrganizationReference: ").Append(ReportingEducationOrganizationReference).Append("\n");
            sb.Append("  StudentEducationOrganizationAssociationReference: ").Append(StudentEducationOrganizationAssociationReference).Append("\n");
            sb.Append("  TestingEducationOrganizationReference: ").Append(TestingEducationOrganizationReference).Append("\n");
            sb.Append("  AssessmentCustomizations: ").Append(AssessmentCustomizations).Append("\n");
            sb.Append("  PlatformTypeDescriptor: ").Append(PlatformTypeDescriptor).Append("\n");
            sb.Append("  Etag: ").Append(Etag).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }
  
        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public string ToJson()
        {
            return JsonConvert.SerializeObject(this, Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as EdFiXAssessmentRosterStudentAssessmentRegistration);
        }

        /// <summary>
        /// Returns true if EdFiXAssessmentRosterStudentAssessmentRegistration instances are equal
        /// </summary>
        /// <param name="input">Instance of EdFiXAssessmentRosterStudentAssessmentRegistration to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(EdFiXAssessmentRosterStudentAssessmentRegistration input)
        {
            if (input == null)
                return false;

            return 
                (
                    this.Id == input.Id ||
                    (this.Id != null &&
                    this.Id.Equals(input.Id))
                ) && 
                (
                    this.AssessmentAdministrationReference == input.AssessmentAdministrationReference ||
                    (this.AssessmentAdministrationReference != null &&
                    this.AssessmentAdministrationReference.Equals(input.AssessmentAdministrationReference))
                ) && 
                (
                    this.ReportingEducationOrganizationReference == input.ReportingEducationOrganizationReference ||
                    (this.ReportingEducationOrganizationReference != null &&
                    this.ReportingEducationOrganizationReference.Equals(input.ReportingEducationOrganizationReference))
                ) && 
                (
                    this.StudentEducationOrganizationAssociationReference == input.StudentEducationOrganizationAssociationReference ||
                    (this.StudentEducationOrganizationAssociationReference != null &&
                    this.StudentEducationOrganizationAssociationReference.Equals(input.StudentEducationOrganizationAssociationReference))
                ) && 
                (
                    this.TestingEducationOrganizationReference == input.TestingEducationOrganizationReference ||
                    (this.TestingEducationOrganizationReference != null &&
                    this.TestingEducationOrganizationReference.Equals(input.TestingEducationOrganizationReference))
                ) && 
                (
                    this.AssessmentCustomizations == input.AssessmentCustomizations ||
                    this.AssessmentCustomizations != null &&
                    this.AssessmentCustomizations.SequenceEqual(input.AssessmentCustomizations)
                ) && 
                (
                    this.PlatformTypeDescriptor == input.PlatformTypeDescriptor ||
                    (this.PlatformTypeDescriptor != null &&
                    this.PlatformTypeDescriptor.Equals(input.PlatformTypeDescriptor))
                ) && 
                (
                    this.Etag == input.Etag ||
                    (this.Etag != null &&
                    this.Etag.Equals(input.Etag))
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.Id != null)
                    hashCode = hashCode * 59 + this.Id.GetHashCode();
                if (this.AssessmentAdministrationReference != null)
                    hashCode = hashCode * 59 + this.AssessmentAdministrationReference.GetHashCode();
                if (this.ReportingEducationOrganizationReference != null)
                    hashCode = hashCode * 59 + this.ReportingEducationOrganizationReference.GetHashCode();
                if (this.StudentEducationOrganizationAssociationReference != null)
                    hashCode = hashCode * 59 + this.StudentEducationOrganizationAssociationReference.GetHashCode();
                if (this.TestingEducationOrganizationReference != null)
                    hashCode = hashCode * 59 + this.TestingEducationOrganizationReference.GetHashCode();
                if (this.AssessmentCustomizations != null)
                    hashCode = hashCode * 59 + this.AssessmentCustomizations.GetHashCode();
                if (this.PlatformTypeDescriptor != null)
                    hashCode = hashCode * 59 + this.PlatformTypeDescriptor.GetHashCode();
                if (this.Etag != null)
                    hashCode = hashCode * 59 + this.Etag.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // PlatformTypeDescriptor (string) maxLength
            if(this.PlatformTypeDescriptor != null && this.PlatformTypeDescriptor.Length > 306)
            {
                yield return new System.ComponentModel.DataAnnotations.ValidationResult("Invalid value for PlatformTypeDescriptor, length must be less than 306.", new [] { "PlatformTypeDescriptor" });
            }

            yield break;
        }
    }

}
